import os
import sys
import statistics

sys.path.insert(0,"/home/lucas/Documents/KYR/bc_thesis/thesis/project/")
import numpy as np
import matplotlib.pyplot as plt


def compute_imp_sum():
    fet_dict = {
        'lep_Pt_1' : 0,
'minDeltaR_LJ_0': 0,
'minOSMll':0,
'sumPsbtag':0,
'nTaus_OR':0,
'taus_pt_0':0,
'taus_RNNJetScore_0':0,
'MtLepMet':0,
'jet_pt0':0,
'DeltaR_min_lep_jet_fwd':0,
'lep_ID_0':0,
'nJets_OR_TauOR':0,
'lep_E_1':0,
'Ptll01':0,
'taus_fromPV_0':0,
'taus_decayMode_0':0,
'lep_E_0':0,
'lep_Pt_0':0,
'dilep_type':0,
'met_met':0,
'taus_JetBDTSigMedium_0':0,
'taus_passJVT_0':0,
'DRll01':0,
'lep_Mtrktrk_atConvV_CO_0':0,
'taus_passEleBDT_0':0,
'taus_charge_0':0,
'dEta_maxMjj_frwdjet':0,
'lep_Eta_0':0,
'lep_ID_1':0,
'taus_DL1r_0':0,
'taus_JetRNNSigLoose_0':0,
'lep_nTrackParticles_0':0,
'jet_eta1':0,
'lep_Phi_1':0,
'total_leptons':0,
'best_Z_Mll':0,
'best_Z_other_MtLepMet':0,
'lep_DFCommonAddAmbiguity_1':0,
'lep_sigd0PV_1':0,
'lep_sigd0PV_0':0,
'nTaus_OR_Pt25':0,
'met_phi':0,
'jet_eta2':0,
'lep_Phi_0':0,
'lep_nTrackParticles_1':0,
'best_Z_other_Mll':0,
'lep_nInnerPix_1':0,
'jet_eta0':0,
'taus_numTrack_0':0,
'jet_pt1':0,
'flag_JetCleaning_LooseBad':0,
'taus_phi_0':0,
'taus_passEleOLR_0':0,
'lep_nInnerPix_0':0,
'Mlll012':0,
'taus_width_0':0,
'taus_RNNJetScoreSigTrans_0':0,
'Mllll0123':0,
'total_charge':0,
'mjjMax_frwdJet':0,
'lep_EtaBE2_0':0,
'minOSSFMll':0,
'HT_lep':0,
'nFwdJets_OR_TauOR':0,
'taus_JetRNNSigMedium_0':0,
'lep_DFCommonAddAmbiguity_0':0,
'Mll01':0,
'taus_JetBDTSigTight_0':0,
'lep_Z0SinTheta_1':0,
'taus_JetRNNSigTight_0':0,
'MLepMet':0,
'DeltaR_min_lep_jet':0,
'minDeltaR_LJ_2':0,
'lep_Mtrktrk_atPV_CO_0':0,
'taus_BDTJetScore_0':0,
'taus_JetBDTSigLoose_0':0,
'lep_Mtrktrk_atPV_CO_1':0,
'taus_eta_0':0,
'taus_BDTJetScoreSigTrans_0':0,
'minDeltaR_LJ_1':0,
'eta_frwdjet':0,
'HT':0,
'HT_fwdJets':0,
'lep_Eta_1':0,
'lep_EtaBE2_1':0,
'lep_Mtrktrk_atConvV_CO_1':0,
'lep_Z0SinTheta_0':0,
'max_eta':0,
'HT_inclFwdJets':0
    }


    feats = [
        'lep_Pt_1',
        'minDeltaR_LJ_0',
        'minOSMll',
        'sumPsbtag',
        'nTaus_OR',
        'taus_pt_0',
        'taus_RNNJetScore_0',
        'MtLepMet',
        'jet_pt0',
        'DeltaR_min_lep_jet_fwd',
        'lep_ID_0',
        'nJets_OR_TauOR',
        'lep_E_1',
        'Ptll01',
        'taus_fromPV_0',
        'taus_decayMode_0',
        'lep_E_0',
        'lep_Pt_0',
        'dilep_type',
        'met_met',
        'taus_JetBDTSigMedium_0',
        'taus_passJVT_0',
        'DRll01',
        'lep_Mtrktrk_atConvV_CO_0',
        'taus_passEleBDT_0',
        'taus_charge_0',
        'dEta_maxMjj_frwdjet',
        'lep_Eta_0',
        'lep_ID_1',
        'taus_DL1r_0',
        'taus_JetRNNSigLoose_0',
        'lep_nTrackParticles_0',
        'jet_eta1',
        'lep_Phi_1',
        'total_leptons',
        'best_Z_Mll',
        'best_Z_other_MtLepMet',
        'lep_DFCommonAddAmbiguity_1',
        'lep_sigd0PV_1',
        'lep_sigd0PV_0',
        'nTaus_OR_Pt25',
        'met_phi',
        'jet_eta2',
        'lep_Phi_0',
        'lep_nTrackParticles_1',
        'best_Z_other_Mll',
        'lep_nInnerPix_1',
        'jet_eta0',
        'taus_numTrack_0',
        'jet_pt1',
        'flag_JetCleaning_LooseBad',
        'taus_phi_0',
        'taus_passEleOLR_0',
        'lep_nInnerPix_0',
        'Mlll012',
        'taus_width_0',
        'taus_RNNJetScoreSigTrans_0',
        'Mllll0123',
        'total_charge',
        'mjjMax_frwdJet',
        'lep_EtaBE2_0',
        'minOSSFMll',
        'HT_lep',
        'nFwdJets_OR_TauOR',
        'taus_JetRNNSigMedium_0',
        'lep_DFCommonAddAmbiguity_0',
        'Mll01',
        'taus_JetBDTSigTight_0',
        'lep_Z0SinTheta_1',
        'taus_JetRNNSigTight_0',
        'MLepMet',
        'DeltaR_min_lep_jet',
        'minDeltaR_LJ_2',
        'lep_Mtrktrk_atPV_CO_0',
        'taus_BDTJetScore_0',
        'taus_JetBDTSigLoose_0',
        'lep_Mtrktrk_atPV_CO_1',
        'taus_eta_0',
        'taus_BDTJetScoreSigTrans_0',
        'minDeltaR_LJ_1',
        'eta_frwdjet',
        'HT',
        'HT_fwdJets',
        'lep_Eta_1',
        'lep_EtaBE2_1',
        'lep_Mtrktrk_atConvV_CO_1',
        'lep_Z0SinTheta_0',
        'max_eta',
        'HT_inclFwdJets',
        'sumPsbtag',
        'lep_Pt_1',
        'taus_JetBDTSigMedium_0',
        'taus_RNNJetScore_0',
        'nJets_OR_TauOR',
        'jet_pt0',
        'taus_pt_0',
        'DeltaR_min_lep_jet_fwd',
        'total_leptons',
        'met_met',
        'MtLepMet',
        'taus_decayMode_0',
        'HT',
        'minOSSFMll',
        'best_Z_other_MtLepMet',
        'best_Z_other_Mll',
        'Mll01',
        'taus_charge_0',
        'DRll01',
        'minDeltaR_LJ_0',
        'flag_JetCleaning_LooseBad',
        'Ptll01',
        'taus_numTrack_0',
        'taus_passEleOLR_0',
        'HT_inclFwdJets',
        'lep_Pt_0',
        'jet_pt1',
        'lep_Z0SinTheta_0',
        'MLepMet',
        'taus_JetBDTSigTight_0',
        'nTaus_OR',
        'lep_Phi_1',
        'taus_JetRNNSigTight_0',
        'taus_JetRNNSigMedium_0',
        'taus_JetBDTSigLoose_0',
        'taus_eta_0',
        'taus_BDTJetScore_0',
        'lep_Mtrktrk_atPV_CO_1',
        'lep_EtaBE2_0',
        'minOSMll',
        'lep_E_1',
        'dEta_maxMjj_frwdjet',
        'taus_BDTJetScoreSigTrans_0',
        'taus_DL1r_0',
        'Mlll012',
        'lep_E_0',
        'jet_eta0',
        'lep_Mtrktrk_atConvV_CO_0',
        'lep_Phi_0',
        'nTaus_OR_Pt25',
        'jet_eta2',
        'DeltaR_min_lep_jet',
        'nFwdJets_OR_TauOR',
        'taus_JetRNNSigLoose_0',
        'lep_DFCommonAddAmbiguity_0',
        'total_charge',
        'lep_Eta_0',
        'lep_Z0SinTheta_1',
        'lep_Mtrktrk_atConvV_CO_1',
        'lep_EtaBE2_1',
        'lep_Mtrktrk_atPV_CO_0',
        'taus_passJVT_0',
        'mjjMax_frwdJet',
        'taus_RNNJetScoreSigTrans_0',
        'taus_width_0',
        'lep_nInnerPix_1',
        'eta_frwdjet',
        'lep_nTrackParticles_1',
        'jet_eta1',
        'lep_nInnerPix_0',
        'dilep_type',
        'lep_DFCommonAddAmbiguity_1',
        'lep_ID_1',
        'taus_phi_0',
        'HT_lep',
        'HT_fwdJets',
        'Mllll0123',
        'lep_sigd0PV_0',
        'taus_passEleBDT_0',
        'lep_ID_0',
        'lep_nTrackParticles_0',
        'lep_sigd0PV_1',
        'lep_Eta_1',
        'max_eta',
        'minDeltaR_LJ_2',
        'met_phi',
        'taus_fromPV_0',
        'best_Z_Mll',
        'minDeltaR_LJ_1',
        'taus_JetBDTSigMedium_0',
        'MtLepMet',
        'lep_Pt_1',
        'jet_pt0',
        'sumPsbtag',
        'Mll01',
        'taus_pt_0',
        'taus_RNNJetScore_0',
        'taus_decayMode_0',
        'eta_frwdjet',
        'Mllll0123',
        'nJets_OR_TauOR',
        'HT_inclFwdJets',
        'dEta_maxMjj_frwdjet',
        'DeltaR_min_lep_jet_fwd',
        'met_met',
        'total_leptons',
        'best_Z_other_Mll',
        'lep_DFCommonAddAmbiguity_0',
        'minDeltaR_LJ_1',
        'total_charge',
        'nTaus_OR',
        'minDeltaR_LJ_0',
        'minOSMll',
        'flag_JetCleaning_LooseBad',
        'lep_Z0SinTheta_1',
        'DeltaR_min_lep_jet',
        'taus_passEleOLR_0',
        'lep_nInnerPix_0',
        'taus_fromPV_0',
        'Mlll012',
        'lep_Phi_0',
        'taus_BDTJetScoreSigTrans_0',
        'lep_nTrackParticles_0',
        'nFwdJets_OR_TauOR',
        'lep_E_0',
        'nTaus_OR_Pt25',
        'lep_sigd0PV_0',
        'taus_JetRNNSigLoose_0',
        'taus_RNNJetScoreSigTrans_0',
        'HT_fwdJets',
        'dilep_type',
        'lep_E_1',
        'jet_eta0',
        'lep_nTrackParticles_1',
        'lep_Mtrktrk_atPV_CO_0',
        'DRll01',
        'taus_JetBDTSigTight_0',
        'lep_ID_1',
        'lep_Eta_0',
        'taus_width_0',
        'taus_charge_0',
        'jet_eta2',
        'MLepMet',
        'HT_lep',
        'Ptll01',
        'lep_sigd0PV_1',
        'lep_EtaBE2_1',
        'met_phi',
        'lep_DFCommonAddAmbiguity_1',
        'max_eta',
        'minDeltaR_LJ_2',
        'jet_eta1',
        'taus_JetRNNSigMedium_0',
        'taus_JetRNNSigTight_0',
        'taus_DL1r_0',
        'HT',
        'taus_passEleBDT_0',
        'best_Z_other_MtLepMet',
        'lep_Pt_0',
        'lep_Mtrktrk_atConvV_CO_0',
        'taus_numTrack_0',
        'mjjMax_frwdJet',
        'best_Z_Mll',
        'taus_eta_0',
        'taus_phi_0',
        'lep_Phi_1',
        'lep_nInnerPix_1',
        'lep_Mtrktrk_atPV_CO_1',
        'taus_BDTJetScore_0',
        'lep_Mtrktrk_atConvV_CO_1',
        'taus_JetBDTSigLoose_0',
        'taus_passJVT_0',
        'lep_ID_0',
        'lep_EtaBE2_0',
        'lep_Eta_1',
        'jet_pt1',
        'minOSSFMll',
        'lep_Z0SinTheta_0',
        'sumPsbtag',
        'taus_RNNJetScore_0',
        'taus_pt_0',
        'met_met',
        'HT',
        'DeltaR_min_lep_jet',
        'HT_lep',
        'nJets_OR_TauOR',
        'MtLepMet',
        'jet_pt1',
        'taus_decayMode_0',
        'total_leptons',
        'minOSSFMll',
        'Mlll012',
        'MLepMet',
        'DeltaR_min_lep_jet_fwd',
        'taus_DL1r_0',
        'lep_E_0',
        'nTaus_OR_Pt25',
        'lep_ID_0',
        'taus_passEleBDT_0',
        'lep_E_1',
        'lep_EtaBE2_1',
        'Mllll0123',
        'max_eta',
        'DRll01',
        'dEta_maxMjj_frwdjet',
        'jet_eta0',
        'HT_fwdJets',
        'taus_BDTJetScore_0',
        'minOSMll',
        'Mll01',
        'taus_JetBDTSigMedium_0',
        'best_Z_other_MtLepMet',
        'taus_JetRNNSigLoose_0',
        'best_Z_other_Mll',
        'taus_fromPV_0',
        'lep_ID_1',
        'nFwdJets_OR_TauOR',
        'taus_eta_0',
        'dilep_type',
        'Ptll01',
        'lep_Mtrktrk_atPV_CO_1',
        'met_phi',
        'taus_passEleOLR_0',
        'taus_JetBDTSigTight_0',
        'taus_passJVT_0',
        'eta_frwdjet',
        'lep_Eta_0',
        'jet_eta1',
        'total_charge',
        'lep_Mtrktrk_atConvV_CO_0',
        'jet_eta2',
        'minDeltaR_LJ_0',
        'lep_Z0SinTheta_1',
        'lep_Pt_1',
        'lep_Mtrktrk_atPV_CO_0',
        'lep_nTrackParticles_1',
        'lep_DFCommonAddAmbiguity_0',
        'lep_nTrackParticles_0',
        'taus_RNNJetScoreSigTrans_0',
        'lep_sigd0PV_1',
        'lep_DFCommonAddAmbiguity_1',
        'lep_sigd0PV_0',
        'best_Z_Mll',
        'taus_BDTJetScoreSigTrans_0',
        'taus_charge_0',
        'taus_phi_0',
        'lep_Z0SinTheta_0',
        'lep_Pt_0',
        'lep_EtaBE2_0',
        'taus_JetRNNSigMedium_0',
        'HT_inclFwdJets',
        'taus_JetRNNSigTight_0',
        'flag_JetCleaning_LooseBad',
        'minDeltaR_LJ_2',
        'lep_Mtrktrk_atConvV_CO_1',
        'lep_nInnerPix_1',
        'lep_Phi_1',
        'nTaus_OR',
        'taus_numTrack_0',
        'mjjMax_frwdJet',
        'jet_pt0',
        'taus_JetBDTSigLoose_0',
        'minDeltaR_LJ_1',
        'lep_Eta_1',
        'taus_width_0',
        'lep_nInnerPix_0',
        'lep_Phi_0',
        'best_Z_Mll',
        'lep_Pt_1',
        'taus_JetBDTSigMedium_0',
        'taus_JetRNNSigLoose_0',
        'met_met',
        'sumPsbtag',
        'minOSMll',
        'MtLepMet',
        'MLepMet',
        'DeltaR_min_lep_jet_fwd',
        'jet_pt0',
        'taus_RNNJetScore_0',
        'Ptll01',
        'lep_Pt_0',
        'lep_ID_0',
        'nJets_OR_TauOR',
        'minDeltaR_LJ_0',
        'lep_Phi_0',
        'HT_inclFwdJets',
        'minDeltaR_LJ_1',
        'best_Z_other_MtLepMet',
        'taus_decayMode_0',
        'lep_Z0SinTheta_0',
        'nFwdJets_OR_TauOR',
        'minOSSFMll',
        'jet_eta2',
        'lep_ID_1',
        'lep_nInnerPix_1',
        'taus_passEleOLR_0',
        'jet_eta1',
        'max_eta',
        'taus_BDTJetScoreSigTrans_0',
        'Mllll0123',
        'lep_EtaBE2_1',
        'nTaus_OR',
        'met_phi',
        'taus_fromPV_0',
        'lep_E_1',
        'lep_DFCommonAddAmbiguity_0',
        'flag_JetCleaning_LooseBad',
        'DRll01',
        'HT_fwdJets',
        'dilep_type',
        'total_leptons',
        'nTaus_OR_Pt25',
        'DeltaR_min_lep_jet',
        'lep_E_0',
        'lep_Mtrktrk_atPV_CO_0',
        'taus_JetBDTSigLoose_0',
        'jet_eta0',
        'dEta_maxMjj_frwdjet',
        'best_Z_other_Mll',
        'HT',
        'Mll01',
        'lep_DFCommonAddAmbiguity_1',
        'mjjMax_frwdJet',
        'taus_pt_0',
        'lep_Phi_1',
        'minDeltaR_LJ_2',
        'lep_Eta_0',
        'lep_sigd0PV_1',
        'taus_eta_0',
        'taus_charge_0',
        'taus_RNNJetScoreSigTrans_0',
        'lep_Mtrktrk_atPV_CO_1',
        'taus_JetRNNSigMedium_0',
        'taus_BDTJetScore_0',
        'taus_JetBDTSigTight_0',
        'lep_EtaBE2_0',
        'taus_JetRNNSigTight_0',
        'taus_passJVT_0',
        'lep_nInnerPix_0',
        'lep_sigd0PV_0',
        'lep_Mtrktrk_atConvV_CO_0',
        'lep_nTrackParticles_0',
        'lep_nTrackParticles_1',
        'taus_phi_0',
        'Mlll012',
        'taus_width_0',
        'total_charge',
        'taus_numTrack_0',
        'taus_DL1r_0',
        'lep_Z0SinTheta_1',
        'eta_frwdjet',
        'lep_Mtrktrk_atConvV_CO_1',
        'HT_lep',
        'lep_Eta_1',
        'jet_pt1',
        'taus_passEleBDT_0',
        'lep_Pt_1',
        'taus_pt_0',
        'sumPsbtag',
        'lep_E_1',
        'MtLepMet',
        'nJets_OR_TauOR',
        'nTaus_OR',
        'best_Z_other_MtLepMet',
        'DRll01',
        'HT_inclFwdJets',
        'total_charge',
        'met_met',
        'Mlll012',
        'flag_JetCleaning_LooseBad',
        'mjjMax_frwdJet',
        'HT_fwdJets',
        'DeltaR_min_lep_jet',
        'jet_pt0',
        'minDeltaR_LJ_0',
        'minOSMll',
        'Ptll01',
        'minOSSFMll',
        'best_Z_other_Mll',
        'total_leptons',
        'lep_Pt_0',
        'lep_nInnerPix_1',
        'taus_JetBDTSigMedium_0',
        'taus_width_0',
        'lep_EtaBE2_1',
        'dEta_maxMjj_frwdjet',
        'taus_JetRNNSigTight_0',
        'taus_BDTJetScoreSigTrans_0',
        'Mllll0123',
        'taus_JetRNNSigLoose_0',
        'DeltaR_min_lep_jet_fwd',
        'lep_sigd0PV_1',
        'lep_DFCommonAddAmbiguity_0',
        'jet_eta0',
        'lep_Phi_1',
        'taus_numTrack_0',
        'lep_ID_0',
        'taus_JetBDTSigLoose_0',
        'taus_decayMode_0',
        'lep_EtaBE2_0',
        'nFwdJets_OR_TauOR',
        'taus_phi_0',
        'nTaus_OR_Pt25',
        'taus_charge_0',
        'lep_Mtrktrk_atPV_CO_1',
        'lep_Eta_1',
        'taus_passJVT_0',
        'lep_nInnerPix_0',
        'lep_Z0SinTheta_1',
        'taus_RNNJetScore_0',
        'dilep_type',
        'taus_RNNJetScoreSigTrans_0',
        'lep_E_0',
        'HT',
        'lep_Eta_0',
        'lep_Z0SinTheta_0',
        'taus_BDTJetScore_0',
        'minDeltaR_LJ_2',
        'max_eta',
        'MLepMet',
        'HT_lep',
        'taus_JetBDTSigTight_0',
        'taus_fromPV_0',
        'Mll01',
        'lep_Phi_0',
        'lep_nTrackParticles_1',
        'taus_JetRNNSigMedium_0',
        'jet_eta2',
        'eta_frwdjet',
        'taus_DL1r_0',
        'met_phi',
        'lep_Mtrktrk_atConvV_CO_0',
        'taus_eta_0',
        'best_Z_Mll',
        'lep_nTrackParticles_0',
        'lep_Mtrktrk_atPV_CO_0',
        'lep_Mtrktrk_atConvV_CO_1',
        'lep_ID_1',
        'lep_DFCommonAddAmbiguity_1',
        'jet_pt1',
        'taus_passEleBDT_0',
        'taus_passEleOLR_0',
        'minDeltaR_LJ_1',
        'jet_eta1',
        'lep_sigd0PV_0',
        'best_Z_Mll',
        'sumPsbtag',
        'lep_Pt_1',
        'taus_pt_0',
        'MtLepMet',
        'taus_BDTJetScoreSigTrans_0',
        'jet_pt1',
        'nJets_OR_TauOR',
        'minDeltaR_LJ_0',
        'jet_pt0',
        'dEta_maxMjj_frwdjet',
        'best_Z_other_MtLepMet',
        'taus_decayMode_0',
        'taus_JetRNNSigMedium_0',
        'Mll01',
        'DeltaR_min_lep_jet_fwd',
        'Mllll0123',
        'lep_ID_0',
        'MLepMet',
        'Ptll01',
        'lep_E_1',
        'taus_passEleBDT_0',
        'taus_passEleOLR_0',
        'lep_Pt_0',
        'minDeltaR_LJ_2',
        'taus_RNNJetScore_0',
        'lep_ID_1',
        'DRll01',
        'lep_Phi_0',
        'max_eta',
        'taus_passJVT_0',
        'taus_JetBDTSigTight_0',
        'taus_phi_0',
        'taus_fromPV_0',
        'taus_JetBDTSigMedium_0',
        'HT',
        'lep_Mtrktrk_atPV_CO_1',
        'DeltaR_min_lep_jet',
        'mjjMax_frwdJet',
        'taus_numTrack_0',
        'nFwdJets_OR_TauOR',
        'jet_eta1',
        'HT_fwdJets',
        'total_leptons',
        'taus_JetRNNSigLoose_0',
        'lep_Phi_1',
        'nTaus_OR',
        'taus_DL1r_0',
        'lep_nInnerPix_1',
        'minDeltaR_LJ_1',
        'lep_Mtrktrk_atPV_CO_0',
        'lep_nTrackParticles_1',
        'best_Z_other_Mll',
        'lep_EtaBE2_1',
        'lep_DFCommonAddAmbiguity_0',
        'taus_charge_0',
        'taus_eta_0',
        'HT_lep',
        'lep_EtaBE2_0',
        'met_met',
        'HT_inclFwdJets',
        'Mlll012',
        'jet_eta0',
        'lep_Eta_0',
        'lep_sigd0PV_0',
        'dilep_type',
        'lep_Z0SinTheta_1',
        'lep_Z0SinTheta_0',
        'taus_BDTJetScore_0',
        'taus_JetRNNSigTight_0',
        'taus_JetBDTSigLoose_0',
        'lep_Mtrktrk_atConvV_CO_0',
        'total_charge',
        'lep_sigd0PV_1',
        'taus_RNNJetScoreSigTrans_0',
        'minOSSFMll',
        'taus_width_0',
        'nTaus_OR_Pt25',
        'minOSMll',
        'lep_Eta_1',
        'jet_eta2',
        'met_phi',
        'flag_JetCleaning_LooseBad',
        'lep_DFCommonAddAmbiguity_1',
        'lep_nTrackParticles_0',
        'lep_nInnerPix_0',
        'lep_Mtrktrk_atConvV_CO_1',
        'eta_frwdjet',
        'lep_E_0',
        'minOSMll',
        'lep_Pt_1',
        'MtLepMet',
        'sumPsbtag',
        'DeltaR_min_lep_jet_fwd',
        'total_leptons',
        'taus_pt_0',
        'taus_RNNJetScore_0',
        'Ptll01',
        'met_met',
        'HT',
        'minDeltaR_LJ_0',
        'minDeltaR_LJ_1',
        'nJets_OR_TauOR',
        'jet_pt1',
        'nTaus_OR_Pt25',
        'dEta_maxMjj_frwdjet',
        'lep_Mtrktrk_atPV_CO_1',
        'lep_ID_0',
        'taus_decayMode_0',
        'MLepMet',
        'Mll01',
        'Mllll0123',
        'lep_Mtrktrk_atConvV_CO_0',
        'jet_pt0',
        'taus_JetBDTSigMedium_0',
        'lep_nTrackParticles_0',
        'nTaus_OR',
        'lep_EtaBE2_0',
        'taus_DL1r_0',
        'taus_fromPV_0',
        'taus_JetRNNSigMedium_0',
        'taus_passEleOLR_0',
        'taus_numTrack_0',
        'nFwdJets_OR_TauOR',
        'lep_Z0SinTheta_1',
        'total_charge',
        'taus_JetRNNSigTight_0',
        'best_Z_other_Mll',
        'HT_fwdJets',
        'lep_DFCommonAddAmbiguity_0',
        'minOSSFMll',
        'met_phi',
        'lep_sigd0PV_0',
        'flag_JetCleaning_LooseBad',
        'jet_eta1',
        'lep_Mtrktrk_atConvV_CO_1',
        'lep_Phi_0',
        'lep_E_0',
        'taus_JetRNNSigLoose_0',
        'taus_JetBDTSigLoose_0',
        'lep_DFCommonAddAmbiguity_1',
        'taus_BDTJetScoreSigTrans_0',
        'taus_charge_0',
        'lep_Z0SinTheta_0',
        'lep_Eta_0',
        'jet_eta2',
        'taus_eta_0',
        'jet_eta0',
        'lep_E_1',
        'DeltaR_min_lep_jet',
        'lep_ID_1',
        'max_eta',
        'taus_RNNJetScoreSigTrans_0',
        'lep_EtaBE2_1',
        'taus_passJVT_0',
        'taus_JetBDTSigTight_0',
        'lep_Phi_1',
        'lep_sigd0PV_1',
        'taus_passEleBDT_0',
        'Mlll012',
        'taus_width_0',
        'dilep_type',
        'DRll01',
        'lep_nInnerPix_0',
        'lep_Eta_1',
        'best_Z_other_MtLepMet',
        'lep_nInnerPix_1',
        'minDeltaR_LJ_2',
        'mjjMax_frwdJet',
        'best_Z_Mll',
        'lep_nTrackParticles_1',
        'taus_BDTJetScore_0',
        'lep_Pt_0',
        'lep_Mtrktrk_atPV_CO_0',
        'eta_frwdjet',
        'taus_phi_0',
        'HT_inclFwdJets',
        'HT_lep',
        'MtLepMet',
        'sumPsbtag',
        'minOSMll',
        'taus_JetBDTSigMedium_0',
        'nJets_OR_TauOR',
        'taus_pt_0',
        'met_met',
        'jet_pt1',
        'taus_JetBDTSigTight_0',
        'nTaus_OR',
        'taus_decayMode_0',
        'flag_JetCleaning_LooseBad',
        'Ptll01',
        'lep_Pt_0',
        'lep_Pt_1',
        'DRll01',
        'lep_Phi_0',
        'lep_ID_0',
        'jet_pt0',
        'total_leptons',
        'HT_fwdJets',
        'minOSSFMll',
        'best_Z_other_Mll',
        'lep_E_1',
        'lep_E_0',
        'minDeltaR_LJ_1',
        'minDeltaR_LJ_0',
        'taus_RNNJetScore_0',
        'Mllll0123',
        'mjjMax_frwdJet',
        'best_Z_other_MtLepMet',
        'taus_passJVT_0',
        'taus_JetRNNSigMedium_0',
        'nFwdJets_OR_TauOR',
        'taus_eta_0',
        'lep_Mtrktrk_atPV_CO_0',
        'lep_Phi_1',
        'nTaus_OR_Pt25',
        'taus_RNNJetScoreSigTrans_0',
        'DeltaR_min_lep_jet',
        'lep_DFCommonAddAmbiguity_0',
        'taus_JetRNNSigLoose_0',
        'best_Z_Mll',
        'HT_inclFwdJets',
        'lep_Z0SinTheta_0',
        'Mll01',
        'taus_passEleOLR_0',
        'Mlll012',
        'lep_ID_1',
        'lep_EtaBE2_1',
        'DeltaR_min_lep_jet_fwd',
        'lep_Mtrktrk_atConvV_CO_0',
        'jet_eta0',
        'HT',
        'lep_sigd0PV_1',
        'jet_eta2',
        'taus_JetBDTSigLoose_0',
        'lep_Eta_1',
        'taus_phi_0',
        'lep_Z0SinTheta_1',
        'jet_eta1',
        'lep_EtaBE2_0',
        'lep_Eta_0',
        'lep_nTrackParticles_1',
        'dEta_maxMjj_frwdjet',
        'lep_Mtrktrk_atPV_CO_1',
        'met_phi',
        'taus_JetRNNSigTight_0',
        'MLepMet',
        'taus_fromPV_0',
        'lep_sigd0PV_0',
        'lep_nInnerPix_1',
        'lep_nInnerPix_0',
        'max_eta',
        'minDeltaR_LJ_2',
        'lep_nTrackParticles_0',
        'taus_numTrack_0',
        'taus_DL1r_0',
        'taus_passEleBDT_0',
        'dilep_type',
        'HT_lep',
        'lep_DFCommonAddAmbiguity_1',
        'taus_BDTJetScoreSigTrans_0',
        'taus_BDTJetScore_0',
        'total_charge',
        'taus_width_0',
        'taus_charge_0',
        'lep_Mtrktrk_atConvV_CO_1',
        'eta_frwdjet',
        'taus_JetBDTSigMedium_0',
        'nJets_OR_TauOR',
        'minOSMll',
        'lep_Pt_1',
        'sumPsbtag',
        'minDeltaR_LJ_0',
        'taus_RNNJetScore_0',
        'lep_ID_0',
        'Mll01',
        'taus_pt_0',
        'best_Z_other_MtLepMet',
        'met_met',
        'Mllll0123',
        'lep_ID_1',
        'MLepMet',
        'minDeltaR_LJ_1',
        'taus_passEleOLR_0',
        'taus_RNNJetScoreSigTrans_0',
        'dilep_type',
        'jet_pt0',
        'DRll01',
        'MtLepMet',
        'nFwdJets_OR_TauOR',
        'dEta_maxMjj_frwdjet',
        'DeltaR_min_lep_jet',
        'minDeltaR_LJ_2',
        'best_Z_Mll',
        'taus_decayMode_0',
        'flag_JetCleaning_LooseBad',
        'DeltaR_min_lep_jet_fwd',
        'taus_BDTJetScore_0',
        'Mlll012',
        'jet_pt1',
        'lep_nInnerPix_1',
        'lep_EtaBE2_1',
        'HT_inclFwdJets',
        'total_leptons',
        'lep_sigd0PV_1',
        'lep_Pt_0',
        'lep_Phi_0',
        'lep_nTrackParticles_0',
        'HT',
        'lep_Phi_1',
        'nTaus_OR_Pt25',
        'nTaus_OR',
        'HT_fwdJets',
        'jet_eta1',
        'taus_JetBDTSigTight_0',
        'jet_eta0',
        'taus_fromPV_0',
        'total_charge',
        'lep_Eta_0',
        'lep_Z0SinTheta_1',
        'lep_Mtrktrk_atPV_CO_0',
        'met_phi',
        'lep_DFCommonAddAmbiguity_0',
        'mjjMax_frwdJet',
        'HT_lep',
        'taus_BDTJetScoreSigTrans_0',
        'Ptll01',
        'taus_passEleBDT_0',
        'eta_frwdjet',
        'lep_nTrackParticles_1',
        'max_eta',
        'lep_E_1',
        'lep_E_0',
        'lep_Mtrktrk_atPV_CO_1',
        'taus_JetBDTSigLoose_0',
        'lep_Mtrktrk_atConvV_CO_0',
        'taus_charge_0',
        'best_Z_other_Mll',
        'taus_passJVT_0',
        'taus_JetRNNSigLoose_0',
        'lep_nInnerPix_0',
        'taus_JetRNNSigTight_0',
        'taus_width_0',
        'jet_eta2',
        'taus_phi_0',
        'lep_Z0SinTheta_0',
        'lep_EtaBE2_0',
        'taus_JetRNNSigMedium_0',
        'taus_numTrack_0',
        'minOSSFMll',
        'taus_DL1r_0',
        'lep_sigd0PV_0',
        'lep_Mtrktrk_atConvV_CO_1',
        'taus_eta_0',
        'lep_Eta_1',
        'lep_DFCommonAddAmbiguity_1',
        'minOSMll',
        'Mlll012',
        'sumPsbtag',
        'taus_pt_0',
        'lep_Pt_1',
        'MtLepMet',
        'minDeltaR_LJ_0',
        'DeltaR_min_lep_jet_fwd',
        'jet_pt1',
        'jet_pt0',
        'nJets_OR_TauOR',
        'met_met',
        'nTaus_OR',
        'taus_RNNJetScore_0',
        'DRll01',
        'best_Z_other_MtLepMet',
        'taus_decayMode_0',
        'lep_ID_0',
        'DeltaR_min_lep_jet',
        'dilep_type',
        'Mll01',
        'lep_E_0',
        'total_leptons',
        'lep_Z0SinTheta_1',
        'lep_nTrackParticles_1',
        'minDeltaR_LJ_1',
        'taus_JetRNNSigLoose_0',
        'lep_Pt_0',
        'HT',
        'lep_DFCommonAddAmbiguity_0',
        'MLepMet',
        'lep_E_1',
        'lep_Mtrktrk_atPV_CO_1',
        'taus_JetBDTSigTight_0',
        'taus_JetRNNSigTight_0',
        'minDeltaR_LJ_2',
        'taus_DL1r_0',
        'lep_EtaBE2_0',
        'lep_Mtrktrk_atConvV_CO_1',
        'nTaus_OR_Pt25',
        'taus_JetBDTSigMedium_0',
        'taus_passEleBDT_0',
        'Ptll01',
        'taus_BDTJetScore_0',
        'jet_eta1',
        'mjjMax_frwdJet',
        'lep_nTrackParticles_0',
        'lep_Eta_0',
        'lep_Mtrktrk_atPV_CO_0',
        'taus_fromPV_0',
        'lep_Z0SinTheta_0',
        'lep_sigd0PV_1',
        'taus_JetBDTSigLoose_0',
        'lep_ID_1',
        'dEta_maxMjj_frwdjet',
        'taus_RNNJetScoreSigTrans_0',
        'lep_sigd0PV_0',
        'jet_eta0',
        'HT_fwdJets',
        'lep_EtaBE2_1',
        'taus_phi_0',
        'lep_Phi_0',
        'taus_eta_0',
        'nFwdJets_OR_TauOR',
        'lep_Mtrktrk_atConvV_CO_0',
        'best_Z_Mll',
        'taus_passEleOLR_0',
        'eta_frwdjet',
        'taus_charge_0',
        'lep_DFCommonAddAmbiguity_1',
        'taus_JetRNNSigMedium_0',
        'HT_lep',
        'HT_inclFwdJets',
        'taus_width_0',
        'lep_Eta_1',
        'max_eta',
        'lep_nInnerPix_0',
        'lep_nInnerPix_1',
        'taus_BDTJetScoreSigTrans_0',
        'met_phi',
        'total_charge',
        'Mllll0123',
        'lep_Phi_1',
        'jet_eta2',
        'taus_numTrack_0',
        'taus_passJVT_0',
        'flag_JetCleaning_LooseBad',
        'best_Z_other_Mll',
        'minOSSFMll',
        'sumPsbtag',
        'met_met',
        'taus_JetBDTSigMedium_0',
        'MtLepMet',
        'taus_RNNJetScore_0',
        'best_Z_Mll',
        'taus_pt_0',
        'DeltaR_min_lep_jet_fwd',
        'lep_Pt_1',
        'taus_decayMode_0',
        'nJets_OR_TauOR',
        'minDeltaR_LJ_0',
        'best_Z_other_MtLepMet',
        'jet_pt0',
        'lep_E_1',
        'total_leptons',
        'Ptll01',
        'lep_E_0',
        'lep_Pt_0',
        'nFwdJets_OR_TauOR',
        'Mll01',
        'taus_passEleBDT_0',
        'best_Z_other_Mll',
        'Mlll012',
        'minOSMll',
        'lep_ID_1',
        'flag_JetCleaning_LooseBad',
        'lep_sigd0PV_0',
        'lep_Mtrktrk_atPV_CO_0',
        'nTaus_OR_Pt25',
        'taus_RNNJetScoreSigTrans_0',
        'HT',
        'dilep_type',
        'taus_eta_0',
        'taus_width_0',
        'lep_Z0SinTheta_0',
        'total_charge',
        'minOSSFMll',
        'DRll01',
        'taus_fromPV_0',
        'jet_pt1',
        'lep_Mtrktrk_atConvV_CO_0',
        'HT_fwdJets',
        'taus_phi_0',
        'taus_passJVT_0',
        'lep_DFCommonAddAmbiguity_1',
        'taus_numTrack_0',
        'taus_passEleOLR_0',
        'lep_nTrackParticles_0',
        'lep_DFCommonAddAmbiguity_0',
        'lep_sigd0PV_1',
        'taus_JetRNNSigLoose_0',
        'taus_JetRNNSigTight_0',
        'lep_Mtrktrk_atConvV_CO_1',
        'taus_JetBDTSigTight_0',
        'mjjMax_frwdJet',
        'DeltaR_min_lep_jet',
        'taus_charge_0',
        'lep_Eta_1',
        'jet_eta1',
        'lep_Phi_0',
        'dEta_maxMjj_frwdjet',
        'lep_Mtrktrk_atPV_CO_1',
        'lep_Z0SinTheta_1',
        'lep_ID_0',
        'lep_Phi_1',
        'met_phi',
        'lep_EtaBE2_1',
        'jet_eta2',
        'taus_JetBDTSigLoose_0',
        'taus_BDTJetScore_0',
        'taus_BDTJetScoreSigTrans_0',
        'Mllll0123',
        'HT_inclFwdJets',
        'taus_JetRNNSigMedium_0',
        'taus_DL1r_0',
        'MLepMet',
        'eta_frwdjet',
        'minDeltaR_LJ_1',
        'HT_lep',
        'jet_eta0',
        'lep_Eta_0',
        'lep_EtaBE2_0',
        'lep_nInnerPix_0',
        'lep_nInnerPix_1',
        'lep_nTrackParticles_1',
        'minDeltaR_LJ_2',
        'max_eta',
        'nTaus_OR',
        'minOSMll',
        'sumPsbtag',
        'taus_decayMode_0',
        'MtLepMet',
        'lep_Pt_1',
        'taus_pt_0',
        'dEta_maxMjj_frwdjet',
        'nJets_OR_TauOR',
        'taus_RNNJetScore_0',
        'minDeltaR_LJ_0',
        'lep_ID_1',
        'lep_Pt_0',
        'lep_E_1',
        'DeltaR_min_lep_jet',
        'DeltaR_min_lep_jet_fwd',
        'HT',
        'minOSSFMll',
        'jet_pt1',
        'taus_JetBDTSigMedium_0',
        'taus_passEleOLR_0',
        'lep_ID_0',
        'nTaus_OR_Pt25',
        'total_leptons',
        'Mlll012',
        'taus_JetRNNSigLoose_0',
        'met_met',
        'best_Z_other_Mll',
        'best_Z_other_MtLepMet',
        'taus_phi_0',
        'taus_passEleBDT_0',
        'Mll01',
        'lep_nInnerPix_1',
        'HT_fwdJets',
        'taus_eta_0',
        'met_phi',
        'taus_fromPV_0',
        'lep_Z0SinTheta_1',
        'jet_eta0',
        'taus_BDTJetScoreSigTrans_0',
        'taus_BDTJetScore_0',
        'Ptll01',
        'lep_Mtrktrk_atPV_CO_1',
        'lep_Eta_0',
        'lep_DFCommonAddAmbiguity_1',
        'best_Z_Mll',
        'lep_sigd0PV_1',
        'lep_DFCommonAddAmbiguity_0',
        'jet_eta1',
        'lep_Mtrktrk_atConvV_CO_1',
        'minDeltaR_LJ_2',
        'taus_DL1r_0',
        'taus_numTrack_0',
        'lep_Z0SinTheta_0',
        'lep_nTrackParticles_0',
        'lep_Mtrktrk_atConvV_CO_0',
        'jet_eta2',
        'jet_pt0',
        'lep_EtaBE2_1',
        'mjjMax_frwdJet',
        'taus_passJVT_0',
        'DRll01',
        'taus_width_0',
        'taus_JetRNNSigTight_0',
        'taus_JetBDTSigLoose_0',
        'taus_RNNJetScoreSigTrans_0',
        'taus_JetBDTSigTight_0',
        'nTaus_OR',
        'nFwdJets_OR_TauOR',
        'lep_EtaBE2_0',
        'lep_sigd0PV_0',
        'eta_frwdjet',
        'dilep_type',
        'lep_Phi_0',
        'Mllll0123',
        'MLepMet',
        'taus_charge_0',
        'minDeltaR_LJ_1',
        'max_eta',
        'lep_Phi_1',
        'lep_nTrackParticles_1',
        'lep_nInnerPix_0',
        'lep_Mtrktrk_atPV_CO_0',
        'lep_Eta_1',
        'taus_JetRNNSigMedium_0',
        'total_charge',
        'HT_lep',
        'HT_inclFwdJets',
        'flag_JetCleaning_LooseBad',
        'lep_E_0',
        'taus_pt_0',
        'met_met',
        'taus_JetBDTSigMedium_0',
        'MtLepMet',
        'jet_pt0',
        'DeltaR_min_lep_jet_fwd',
        'sumPsbtag',
        'lep_Pt_1',
        'Mll01',
        'best_Z_other_MtLepMet',
        'nJets_OR_TauOR',
        'jet_pt1',
        'HT',
        'taus_RNNJetScore_0',
        'minOSSFMll',
        'best_Z_Mll',
        'lep_E_1',
        'nTaus_OR_Pt25',
        'taus_phi_0',
        'lep_E_0',
        'taus_charge_0',
        'taus_JetBDTSigTight_0',
        'lep_ID_1',
        'HT_inclFwdJets',
        'taus_fromPV_0',
        'Mlll012',
        'lep_Phi_1',
        'taus_numTrack_0',
        'taus_BDTJetScoreSigTrans_0',
        'total_leptons',
        'DRll01',
        'taus_DL1r_0',
        'lep_Z0SinTheta_1',
        'nTaus_OR',
        'lep_DFCommonAddAmbiguity_0',
        'taus_BDTJetScore_0',
        'taus_passEleOLR_0',
        'lep_Phi_0',
        'lep_Z0SinTheta_0',
        'jet_eta2',
        'lep_Pt_0',
        'taus_JetRNNSigLoose_0',
        'Ptll01',
        'lep_Mtrktrk_atConvV_CO_1',
        'dEta_maxMjj_frwdjet',
        'lep_Mtrktrk_atConvV_CO_0',
        'max_eta',
        'taus_width_0',
        'Mllll0123',
        'HT_lep',
        'total_charge',
        'MLepMet',
        'dilep_type',
        'HT_fwdJets',
        'jet_eta0',
        'taus_decayMode_0',
        'lep_DFCommonAddAmbiguity_1',
        'taus_JetRNNSigTight_0',
        'met_phi',
        'lep_Eta_0',
        'minDeltaR_LJ_1',
        'lep_EtaBE2_0',
        'lep_nTrackParticles_1',
        'lep_ID_0',
        'minDeltaR_LJ_2',
        'taus_RNNJetScoreSigTrans_0',
        'taus_JetRNNSigMedium_0',
        'lep_nTrackParticles_0',
        'best_Z_other_Mll',
        'DeltaR_min_lep_jet',
        'lep_sigd0PV_0',
        'lep_nInnerPix_1',
        'jet_eta1',
        'taus_passJVT_0',
        'eta_frwdjet',
        'lep_nInnerPix_0',
        'taus_eta_0',
        'nFwdJets_OR_TauOR',
        'lep_Mtrktrk_atPV_CO_1',
        'lep_Mtrktrk_atPV_CO_0',
        'flag_JetCleaning_LooseBad',
        'mjjMax_frwdJet',
        'taus_JetBDTSigLoose_0',
        'minDeltaR_LJ_0',
        'minOSMll',
        'lep_EtaBE2_1',
        'taus_passEleBDT_0',
        'lep_Eta_1',
        'lep_sigd0PV_1',
        'taus_JetBDTSigMedium_0',
        'sumPsbtag',
        'MtLepMet',
        'lep_Pt_1',
        'jet_pt0',
        'nTaus_OR_Pt25',
        'taus_RNNJetScore_0',
        'DeltaR_min_lep_jet_fwd',
        'DRll01',
        'minDeltaR_LJ_0',
        'lep_Pt_0',
        'nJets_OR_TauOR',
        'lep_ID_1',
        'met_met',
        'taus_pt_0',
        'dEta_maxMjj_frwdjet',
        'total_charge',
        'nTaus_OR',
        'Ptll01',
        'HT',
        'HT_fwdJets',
        'taus_passJVT_0',
        'best_Z_other_MtLepMet',
        'HT_inclFwdJets',
        'taus_RNNJetScoreSigTrans_0',
        'lep_E_1',
        'taus_passEleBDT_0',
        'lep_sigd0PV_0',
        'total_leptons',
        'lep_Phi_0',
        'flag_JetCleaning_LooseBad',
        'taus_JetRNNSigLoose_0',
        'best_Z_Mll',
        'jet_pt1',
        'minDeltaR_LJ_1',
        'taus_JetRNNSigMedium_0',
        'lep_E_0',
        'Mll01',
        'lep_ID_0',
        'taus_BDTJetScoreSigTrans_0',
        'Mlll012',
        'taus_phi_0',
        'taus_decayMode_0',
        'lep_Eta_1',
        'taus_passEleOLR_0',
        'lep_Mtrktrk_atPV_CO_1',
        'jet_eta0',
        'taus_charge_0',
        'lep_Eta_0',
        'lep_Phi_1',
        'taus_JetBDTSigTight_0',
        'taus_BDTJetScore_0',
        'jet_eta2',
        'minDeltaR_LJ_2',
        'lep_nInnerPix_1',
        'lep_Mtrktrk_atPV_CO_0',
        'lep_Z0SinTheta_0',
        'dilep_type',
        'taus_JetBDTSigLoose_0',
        'eta_frwdjet',
        'lep_DFCommonAddAmbiguity_0',
        'lep_nTrackParticles_0',
        'met_phi',
        'DeltaR_min_lep_jet',
        'max_eta',
        'lep_sigd0PV_1',
        'taus_eta_0',
        'lep_EtaBE2_1',
        'lep_DFCommonAddAmbiguity_1',
        'taus_numTrack_0',
        'taus_JetRNNSigTight_0',
        'lep_nInnerPix_0',
        'lep_Mtrktrk_atConvV_CO_0',
        'Mllll0123',
        'HT_lep',
        'jet_eta1',
        'taus_fromPV_0',
        'mjjMax_frwdJet',
        'lep_nTrackParticles_1',
        'taus_DL1r_0',
        'MLepMet',
        'lep_Z0SinTheta_1',
        'lep_EtaBE2_0',
        'best_Z_other_Mll',
        'taus_width_0',
        'lep_Mtrktrk_atConvV_CO_1',
        'minOSSFMll',
        'minOSMll',
        'nFwdJets_OR_TauOR',
        'sumPsbtag',
        'MtLepMet',
        'lep_Pt_1',
        'nJets_OR_TauOR',
        'DeltaR_min_lep_jet_fwd',
        'taus_JetBDTSigMedium_0',
        'Mll01',
        'taus_pt_0',
        'minDeltaR_LJ_0',
        'taus_RNNJetScore_0',
        'met_met',
        'Mllll0123',
        'flag_JetCleaning_LooseBad',
        'jet_pt1',
        'taus_JetRNNSigLoose_0',
        'best_Z_Mll',
        'best_Z_other_MtLepMet',
        'lep_ID_1',
        'taus_decayMode_0',
        'HT_fwdJets',
        'Ptll01',
        'minDeltaR_LJ_1',
        'taus_eta_0',
        'lep_E_0',
        'taus_DL1r_0',
        'DRll01',
        'best_Z_other_Mll',
        'HT',
        'taus_RNNJetScoreSigTrans_0',
        'minDeltaR_LJ_2',
        'lep_DFCommonAddAmbiguity_1',
        'lep_Eta_1',
        'jet_eta1',
        'jet_eta0',
        'DeltaR_min_lep_jet',
        'taus_fromPV_0',
        'taus_BDTJetScoreSigTrans_0',
        'lep_ID_0',
        'taus_passEleBDT_0',
        'total_leptons',
        'lep_nTrackParticles_0',
        'lep_DFCommonAddAmbiguity_0',
        'Mlll012',
        'MLepMet',
        'lep_Phi_1',
        'lep_EtaBE2_1',
        'lep_Z0SinTheta_1',
        'taus_JetRNNSigTight_0',
        'minOSSFMll',
        'lep_Mtrktrk_atConvV_CO_0',
        'taus_passEleOLR_0',
        'lep_Phi_0',
        'lep_E_1',
        'dEta_maxMjj_frwdjet',
        'nTaus_OR',
        'taus_JetBDTSigTight_0',
        'taus_phi_0',
        'lep_nInnerPix_0',
        'lep_Z0SinTheta_0',
        'met_phi',
        'taus_charge_0',
        'taus_JetBDTSigLoose_0',
        'dilep_type',
        'lep_nTrackParticles_1',
        'lep_Eta_0',
        'total_charge',
        'mjjMax_frwdJet',
        'taus_width_0',
        'nFwdJets_OR_TauOR',
        'lep_sigd0PV_1',
        'lep_Mtrktrk_atPV_CO_1',
        'HT_lep',
        'taus_BDTJetScore_0',
        'jet_eta2',
        'lep_nInnerPix_1',
        'max_eta',
        'taus_JetRNNSigMedium_0',
        'eta_frwdjet',
        'lep_Pt_0',
        'HT_inclFwdJets',
        'nTaus_OR_Pt25',
        'lep_EtaBE2_0',
        'minOSMll',
        'taus_numTrack_0',
        'taus_passJVT_0',
        'lep_Mtrktrk_atPV_CO_0',
        'jet_pt0',
        'lep_Mtrktrk_atConvV_CO_1',
        'lep_sigd0PV_0',
        'sumPsbtag',
        'MtLepMet',
        'taus_pt_0',
        'Mllll0123',
        'minOSSFMll',
        'DeltaR_min_lep_jet_fwd',
        'nJets_OR_TauOR',
        'taus_RNNJetScore_0',
        'minDeltaR_LJ_0',
        'max_eta',
        'lep_ID_0',
        'best_Z_other_Mll',
        'Mll01',
        'taus_passEleBDT_0',
        'Mlll012',
        'jet_pt1',
        'met_met',
        'jet_pt0',
        'lep_Pt_1',
        'lep_E_0',
        'best_Z_other_MtLepMet',
        'HT_inclFwdJets',
        'taus_JetRNNSigLoose_0',
        'flag_JetCleaning_LooseBad',
        'lep_E_1',
        'taus_numTrack_0',
        'taus_JetBDTSigTight_0',
        'DeltaR_min_lep_jet',
        'nTaus_OR',
        'MLepMet',
        'Ptll01',
        'taus_JetBDTSigMedium_0',
        'taus_JetRNNSigMedium_0',
        'lep_DFCommonAddAmbiguity_0',
        'taus_RNNJetScoreSigTrans_0',
        'taus_decayMode_0',
        'taus_BDTJetScoreSigTrans_0',
        'dEta_maxMjj_frwdjet',
        'taus_JetRNNSigTight_0',
        'total_charge',
        'dilep_type',
        'nFwdJets_OR_TauOR',
        'minDeltaR_LJ_1',
        'taus_fromPV_0',
        'DRll01',
        'jet_eta2',
        'lep_EtaBE2_0',
        'lep_Z0SinTheta_1',
        'taus_charge_0',
        'lep_Phi_0',
        'lep_Mtrktrk_atPV_CO_1',
        'HT',
        'taus_JetBDTSigLoose_0',
        'mjjMax_frwdJet',
        'lep_DFCommonAddAmbiguity_1',
        'nTaus_OR_Pt25',
        'lep_Mtrktrk_atPV_CO_0',
        'minOSMll',
        'lep_nTrackParticles_0',
        'taus_passJVT_0',
        'taus_DL1r_0',
        'lep_nTrackParticles_1',
        'minDeltaR_LJ_2',
        'lep_Eta_0',
        'lep_sigd0PV_0',
        'lep_Z0SinTheta_0',
        'jet_eta1',
        'lep_Phi_1',
        'taus_width_0',
        'eta_frwdjet',
        'lep_Mtrktrk_atConvV_CO_1',
        'HT_lep',
        'taus_eta_0',
        'lep_Mtrktrk_atConvV_CO_0',
        'lep_ID_1',
        'lep_nInnerPix_0',
        'taus_phi_0',
        'lep_nInnerPix_1',
        'taus_BDTJetScore_0',
        'met_phi',
        'lep_EtaBE2_1',
        'lep_Eta_1',
        'lep_Pt_0',
        'jet_eta0',
        'lep_sigd0PV_1',
        'HT_fwdJets',
        'taus_passEleOLR_0',
        'best_Z_Mll',
        'total_leptons',
        'lep_Pt_1',
        'sumPsbtag',
        'taus_JetBDTSigMedium_0',
        'taus_RNNJetScore_0',
        'MtLepMet',
        'best_Z_Mll',
        'taus_pt_0',
        'met_met',
        'nJets_OR_TauOR',
        'lep_Mtrktrk_atPV_CO_1',
        'Mll01',
        'jet_pt1',
        'Ptll01',
        'jet_pt0',
        'minDeltaR_LJ_0',
        'taus_decayMode_0',
        'total_leptons',
        'nTaus_OR',
        'taus_passEleBDT_0',
        'minOSSFMll',
        'DeltaR_min_lep_jet_fwd',
        'lep_E_1',
        'DeltaR_min_lep_jet',
        'taus_width_0',
        'HT',
        'HT_inclFwdJets',
        'lep_ID_0',
        'met_phi',
        'lep_sigd0PV_1',
        'taus_JetBDTSigTight_0',
        'Mllll0123',
        'lep_Phi_1',
        'total_charge',
        'Mlll012',
        'jet_eta2',
        'nFwdJets_OR_TauOR',
        'lep_Eta_0',
        'taus_fromPV_0',
        'lep_Pt_0',
        'MLepMet',
        'jet_eta0',
        'dilep_type',
        'taus_eta_0',
        'taus_passJVT_0',
        'minOSMll',
        'jet_eta1',
        'lep_EtaBE2_0',
        'lep_Mtrktrk_atPV_CO_0',
        'lep_ID_1',
        'lep_nInnerPix_1',
        'lep_nInnerPix_0',
        'taus_phi_0',
        'taus_charge_0',
        'lep_Z0SinTheta_0',
        'lep_Mtrktrk_atConvV_CO_1',
        'nTaus_OR_Pt25',
        'lep_Z0SinTheta_1',
        'best_Z_other_Mll',
        'max_eta',
        'dEta_maxMjj_frwdjet',
        'taus_RNNJetScoreSigTrans_0',
        'taus_BDTJetScoreSigTrans_0',
        'taus_passEleOLR_0',
        'lep_DFCommonAddAmbiguity_1',
        'minDeltaR_LJ_1',
        'minDeltaR_LJ_2',
        'eta_frwdjet',
        'lep_sigd0PV_0',
        'taus_DL1r_0',
        'mjjMax_frwdJet',
        'best_Z_other_MtLepMet',
        'HT_fwdJets',
        'taus_numTrack_0',
        'taus_JetRNNSigTight_0',
        'taus_JetBDTSigLoose_0',
        'lep_DFCommonAddAmbiguity_0',
        'lep_E_0',
        'taus_BDTJetScore_0',
        'lep_Phi_0',
        'taus_JetRNNSigLoose_0',
        'taus_JetRNNSigMedium_0',
        'lep_nTrackParticles_1',
        'flag_JetCleaning_LooseBad',
        'HT_lep',
        'lep_Eta_1',
        'lep_EtaBE2_1',
        'lep_Mtrktrk_atConvV_CO_0',
        'lep_nTrackParticles_0',
        'DRll01',
        'sumPsbtag',
        'Mll01',
        'taus_JetBDTSigMedium_0',
        'lep_Pt_1',
        'MtLepMet',
        'met_met',
        'nJets_OR_TauOR',
        'dEta_maxMjj_frwdjet',
        'lep_ID_0',
        'taus_pt_0',
        'taus_RNNJetScore_0',
        'jet_pt0',
        'best_Z_Mll',
        'taus_decayMode_0',
        'total_leptons',
        'HT',
        'taus_passEleBDT_0',
        'Ptll01',
        'minDeltaR_LJ_0',
        'minDeltaR_LJ_1',
        'nTaus_OR',
        'lep_Pt_0',
        'mjjMax_frwdJet',
        'taus_JetBDTSigTight_0',
        'best_Z_other_MtLepMet',
        'lep_Z0SinTheta_1',
        'minOSMll',
        'MLepMet',
        'taus_eta_0',
        'best_Z_other_Mll',
        'lep_E_0',
        'taus_phi_0',
        'jet_eta1',
        'taus_fromPV_0',
        'lep_E_1',
        'lep_Phi_0',
        'taus_passJVT_0',
        'taus_JetRNNSigLoose_0',
        'DeltaR_min_lep_jet_fwd',
        'taus_RNNJetScoreSigTrans_0',
        'taus_JetRNNSigTight_0',
        'lep_Mtrktrk_atPV_CO_0',
        'minOSSFMll',
        'HT_inclFwdJets',
        'taus_charge_0',
        'taus_JetRNNSigMedium_0',
        'Mlll012',
        'lep_nInnerPix_0',
        'HT_fwdJets',
        'lep_nTrackParticles_1',
        'taus_passEleOLR_0',
        'lep_ID_1',
        'nTaus_OR_Pt25',
        'DeltaR_min_lep_jet',
        'jet_pt1',
        'flag_JetCleaning_LooseBad',
        'DRll01',
        'taus_BDTJetScore_0',
        'minDeltaR_LJ_2',
        'taus_JetBDTSigLoose_0',
        'lep_Z0SinTheta_0',
        'dilep_type',
        'max_eta',
        'lep_sigd0PV_0',
        'lep_Phi_1',
        'lep_DFCommonAddAmbiguity_1',
        'lep_nInnerPix_1',
        'total_charge',
        'lep_nTrackParticles_0',
        'lep_DFCommonAddAmbiguity_0',
        'jet_eta0',
        'lep_Eta_0',
        'taus_DL1r_0',
        'lep_Mtrktrk_atPV_CO_1',
        'HT_lep',
        'met_phi',
        'lep_Mtrktrk_atConvV_CO_0',
        'lep_Mtrktrk_atConvV_CO_1',
        'taus_width_0',
        'nFwdJets_OR_TauOR',
        'eta_frwdjet',
        'taus_BDTJetScoreSigTrans_0',
        'Mllll0123',
        'lep_sigd0PV_1',
        'lep_EtaBE2_1',
        'lep_Eta_1',
        'taus_numTrack_0',
        'jet_eta2',
        'lep_EtaBE2_0',
    ]

    for idx, val in enumerate(feats):
        fet_dict[feats[idx]] += idx%89

    fet_dict = dict(sorted(fet_dict.items(), key=lambda item: item[1]))


    for key in enumerate(fet_dict):
        print(key[1])